- Move functions that might be used in class-specific cleanup functions

(geom_test_cleanup, etc) down so the testcases don't emit noise when
  bailing
- Conform to the TAP protocol better when dealing with classes that can't
  be loaded and with temporary files that can't be allocated for tracking
  md(4) devices.

MFC after: 2 weeks
X-MFC with: r293028, r293029, r293048
Sponsored by: EMC / Isilon Storage Division
This commit is contained in:
Enji Cooper 2016-01-08 21:47:41 +00:00
parent eb028f7b2d
commit f009f68a21
Notes: svn2git 2020-12-20 02:59:44 +00:00
svn path=/head/; revision=293444

View File

@ -1,13 +1,6 @@
#!/bin/sh
# $FreeBSD$
if [ $(id -u) -ne 0 ]; then
echo 'Tests must be run as root'
echo 'Bail out!'
exit 1
fi
kldstat -q -m g_${class} || geom ${class} load || exit 1
devwait()
{
while :; do
@ -18,13 +11,6 @@ devwait()
done
}
# Need to keep track of the test md devices to avoid the scenario where a test
# failing will cause the other tests to bomb out, or a test failing will leave
# a large number of md(4) devices lingering around
: ${TMPDIR=/tmp}
export TMPDIR
TEST_MDS_FILE=$(mktemp ${TMPDIR}/test_mds.XXXXXX) || exit 1
attach_md()
{
local test_md
@ -38,12 +24,37 @@ geom_test_cleanup()
{
local test_md
if [ -f $TEST_MDS_FILE ]; then
if [ -f "$TEST_MDS_FILE" ]; then
while read test_md; do
# The "#" tells the TAP parser this is a comment
echo "# Removing test memory disk: $test_md"
mdconfig -d -u $test_md
done < $TEST_MDS_FILE
fi
rm -f $TEST_MDS_FILE
rm -f "$TEST_MDS_FILE"
}
if [ $(id -u) -ne 0 ]; then
echo 'Tests must be run as root'
echo 'Bail out!'
exit 1
fi
# If the geom class isn't already loaded, try loading it.
if ! kldstat -q -m g_${class}; then
if ! geom ${class} load; then
echo "Could not load module for geom class=${class}"
echo 'Bail out!'
exit 1
fi
fi
# Need to keep track of the test md devices to avoid the scenario where a test
# failing will cause the other tests to bomb out, or a test failing will leave
# a large number of md(4) devices lingering around
: ${TMPDIR=/tmp}
export TMPDIR
if ! TEST_MDS_FILE=$(mktemp ${TMPDIR}/test_mds.XXXXXX); then
echo 'Failed to create temporary file for tracking the test md(4) devices'
echo 'Bail out!'
exit 1
fi